<?

#ob_start();
ob_start("ob_gzhandler");

require_once("include/bittorrent.php");
require_once("include/benc.php");

hit_start();

function err($msg) {
	benc_resp(array("failure reason" => array(type => "string", value => $msg)));
	hit_end();
	exit();
}

function benc_resp($d) {
	benc_resp_raw(benc(array(type => "dictionary", value => $d)));
}

function benc_resp_raw($x) {
	header("Content-Type: text/plain");
	header("Pragma: no-cache");
	print($x);
}

$req = "info_hash:peer_id:!ip:port:uploaded:downloaded:left:!event";
foreach (explode(":", $req) as $x) {
	if ($x[0] == "!") {
		$x = substr($x, 1);
		$opt = 1;
	}
	else
		$opt = 0;
	if (!isset($_GET[$x])) {
		if (!$opt)
			err("missing key");
		continue;
	}
	$GLOBALS[$x] = unesc($_GET[$x]);
}

foreach (array("info_hash","peer_id") as $x) {
	if (strlen($GLOBALS[$x]) != 20)
		err("invalid $x (" . strlen($GLOBALS[$x]) . " - " . urlencode($GLOBALS[$x]) . ")");
}

if (empty($ip) || !preg_match('/^(\d{1,3}\.){3}\d{1,3}$/s', $ip))
	$ip = $_SERVER["REMOTE_ADDR"];

$port = 0 + $port;
$downloaded = 0 + $downloaded;
$uploaded = 0 + $uploaded;
$left = 0 + $left;

$rsize = 50;
foreach(array("num want", "numwant", "num_want") as $k) {
	if (isset($_GET[$k])) {
		$rsize = 0 + $_GET[$k];
		break;
	}
}

if (!$port || $port > 0xffff)
	err("invalid port");

if (!isset($event))
	$event = "";

$seeder = ($left == 0) ? "yes" : "no";

dbconn(0);

hit_count();

$res = mysql_query("SELECT id, banned, seeders + leechers AS numpeers FROM torrents WHERE " . hash_where("info_hash", $info_hash));

$torrent = mysql_fetch_assoc($res);
if (!$torrent)
	err("torrent not registered with this tracker");

$do_bookkeeping = false;
$torrentid = 0 + $torrent["id"];
$numpeers = 0 + $torrent["numpeers"];

$fields = "seeder, peer_id, ip, port";

$limit = "";
if ($numpeers > $rsize)     # default 50, or specified by "num_want"
	$limit = "ORDER BY RAND() LIMIT $rsize";
$res = mysql_query("SELECT $fields FROM peers WHERE torrent = $torrentid AND connectable = 'yes' $limit");

$resp = "d" . benc_str("interval") . "i" . $announce_interval . "e" . benc_str("peers") . "l";
unset($self);
while ($row = mysql_fetch_assoc($res)) {
    # go through the list of (connectable) peers

	$row["peer_id"] = hash_pad($row["peer_id"]);

    # if this is us, save the row and continue (no need to return the caller's row to himself)
	if ($row["peer_id"] === $peer_id) {
		$self = $row;
		continue;
	}

    # add the peer to the list that we'll return
	$resp .= "d" .
		benc_str("ip") . benc_str($row["ip"]) .
		benc_str("peer id") . benc_str($row["peer_id"]) .
		benc_str("port") . "i" . $row["port"] . "e" .
		"e";
}

# end of list, end of response dictionary
$resp .= "ee";

$selfwhere = "torrent = $torrentid AND " . hash_where("peer_id", $peer_id);

# if we haven't seen 'our' row yet, get it (such as when there's more than 50 peers, and we limited the result set)
if (!isset($self)) {
	$res = mysql_query("SELECT $fields FROM peers WHERE $selfwhere");
	$row = mysql_fetch_assoc($res);
	if ($row)
		$self = $row;
}

$updateset = array();

if ($event == "stopped") {
	if (isset($self)) {         # a peer signaling 'stopped' that wasn't already in the DB doesn't make sense
		mysql_query("DELETE FROM peers WHERE $selfwhere");
		if (mysql_affected_rows()) {
			if ($self["seeder"] == "yes") {
				$updateset[] = "seeders = seeders - 1";
			} else {
				$updateset[] = "leechers = leechers - 1";
			}			
		}
        $do_bookkeeping = true;
	}
} else {
	if ($event == "completed") {
		$updateset[] = "times_completed = times_completed + 1";
        $do_bookkeeping = true;
	}	

	if (isset($self)) {
		mysql_query("UPDATE peers SET ip = " . sqlesc($ip) . ", port = $port, uploaded = $uploaded, downloaded = $downloaded, to_go = $left, last_action = NOW(), seeder = '$seeder' WHERE $selfwhere");

        # did the peer transition from seed->leech or vice versa?  $self["seeder"] is prev. state, $seeder is current state (based on "left" param)
		if (mysql_affected_rows() && $self["seeder"] != $seeder) {
			if ($seeder == "yes") {
				$updateset[] = "seeders = seeders + 1";
				$updateset[] = "leechers = leechers - 1";
			} else {
				$updateset[] = "seeders = seeders - 1";
				$updateset[] = "leechers = leechers + 1";
			}
            $do_bookkeeping = true;
		}
	} else {
/*
        $ip_parts = explode(".", $ip);
        if(count($ip_parts) == 4) {
            $reverse = implode(".", array_reverse($ip_parts));
            
            # our local named has a "whitelist" zone
            $res = gethostbyname($reverse . ".whitelist");
            if($res != "127.0.0.2") {

                # http://abuse.easynet.nl/proxies.html
                $res = gethostbyname($reverse . ".proxies.blackholes.easynet.nl");
                if($res == "127.0.0.2") {
                    user_error("Tracker refusing open proxy $ip (proxies.blackholes.easynet.nl => $res)", E_USER_NOTICE);
                    err("not allowed to connect from an open proxy (easynet.nl proxies list)");
                }              
    
                # http://www.monkeys.com/upl/
                $res = gethostbyname($reverse . "proxies.relays.monkeys.com");
                if($res == "127.0.0.2") {
                    user_error("Tracker refusing open proxy $ip (proxies.relays.monkeys.com => $res)", E_USER_NOTICE);
                    err("not allowed to connect from an open proxy (monkeys.com UPL)");
                }              
                            
                # http://opm.blitzed.org/info
                $res = gethostbyname($reverse . ".opm.blitzed.org");
                if(preg_match("/^127\.1\.0\.\d+$/", $res)) {
                    user_error("Tracker refusing open proxy $ip (opm.blitzed.org => $res)", E_USER_NOTICE);
                    err("not allowed to connect from an open proxy (opm.blitzed.org)");
                }
    
                $res = gethostbyname($reverse . ".http.dnsbl.sorbs.net");
                if($res == "127.0.0.2") {
                    user_error("Tracker refusing open proxy $ip (http.dnsbl.sorbs.net => $res)", E_USER_NOTICE);
                    err("not allowed to connect from an open HTTP proxy (sorbs.net)");
                }
    
                $res = gethostbyname($reverse . ".socks.dnsbl.sorbs.net");
                if($res == "127.0.0.2") {
                    user_error("Tracker refusing open proxy $ip (socks.dnsbl.sorbs.net => $res)", E_USER_NOTICE);
                    err("not allowed to connect from an open SOCKS proxy (sorbs.net)");
                }
    
                $res = gethostbyname($reverse . ".misc.dnsbl.sorbs.net");
                if($res == "127.0.0.2") {
                    user_error("Tracker refusing open proxy $ip (misc.dnsbl.sorbs.net => $res)", E_USER_NOTICE);
                    err("not allowed to connect from an open proxy (sorbs.net)");
                }
    
                # http://bl.reynolds.net.au/owps/
                $res = gethostbyname($reverse . ".owps.bl.reynolds.net.au");
                if($res == "127.0.0.2") {
                    user_error("Tracker refusing open proxy $ip (owps.bl.reynolds.net.au => $res)", E_USER_NOTICE);
                    err("not allowed to connect from an open WinGate proxy (owps.bl.reynolds.net.au)");
                }
            }
        }
*/

		$sockres = @fsockopen($ip, $port, $errno, $errstr, 5);
		if (!$sockres)
			$connectable = "no";
		else {
			$connectable = "yes";
			@fclose($sockres);
		}

        # this is a new peer we haven't seen yet
		$ret = mysql_query("INSERT INTO peers (connectable, torrent, peer_id, ip, port, uploaded, downloaded, to_go, started, last_action, seeder) VALUES ('$connectable', $torrentid, " . sqlesc($peer_id) . ", " . sqlesc($ip) . ", $port, $uploaded, $downloaded, $left, NOW(), NOW(), '$seeder')");
		if ($ret) {
			if ($seeder == "yes") {
				$updateset[] = "seeders = seeders + 1";
				$numseeders++;
            } else {
				$updateset[] = "leechers = leechers + 1";
				$numleechers++;
			}			
		}
        $do_bookkeeping = true;
	}
}

if ($seeder == "yes") {
	if ($torrent["banned"] != "yes")
		$updateset[] = "visible = 'yes'";
	$updateset[] = "last_action = NOW()";
}

if (count($updateset))
	mysql_query("UPDATE torrents SET " . join(",", $updateset) . " WHERE id = $torrentid");

if ($do_bookkeeping)
    bookkeeping($torrentid);

benc_resp_raw($resp);

hit_end();

?>
